library zigzag;

{  ZigZag        
               .

   Depth   - ,      
   ()  ()  Deviation ,  ,  
    ZigZag  ,   (  ) ,   Deviation, ZigZag    Depth . Backstep       ().

    ,  ZigZag   ,    
      ,        
   .      ,  (   
     )  ZigZag    (  
    )   .

          .

 }

uses
  SysUtils,
  classes,
  graphics,
  windows,
  IndicatorInterfaceUnit,
  TechnicalFunctions in 'TechnicalFunctions.pas';

var

  //  
  Depth, Deviation, BackStep : integer;



  //  
  highBuffer, lowBuffer : TIndexBuffer;


//---------------------------------------------------------------------------

//  

//---------------------------------------------------------------------------

procedure Init; stdcall;

begin

//  

  IndicatorShortName('ZigZag');      //  ZigZug

  SetOutputWindow(ow_ChartWindow);


  //  

  AddSeparator('Common');

  RegOption('Depth', ot_Integer, Depth);

  SetOptionRange('Depth', 1, MaxInt);

  Depth := 12;



  RegOption('Deviation', ot_Integer, Deviation);

  SetOptionRange('Deviation', 1, MaxInt);

  Deviation := 5;

 

  RegOption('Slowing', ot_Integer, BackStep);

  SetOptionRange('BackStep', 1, MaxInt);

  BackStep := 3;


  //   

  highBuffer := CreateIndexBuffer;  //   

  lowBuffer := CreateIndexBuffer;

  IndicatorBuffers(1);

  SetIndexBuffer(0, lowBuffer);

  SetIndexStyle(0, ds_Section, psSolid, 1, clYellow);


end;

 

//---------------------------------------------------------------------------

//  

//---------------------------------------------------------------------------

procedure Done; stdcall;

begin

  // .  



end;

 

//---------------------------------------------------------------------------

//    

//---------------------------------------------------------------------------

procedure Calculate(index: integer); stdcall;
var
  shift,back : integer;
  res, val : double;
  lasthighpos, lastlowpos : integer;
  curLow,curHigh,lastHigh,lastLow : double;
begin

  // .   
  if index <> 0 then exit;

  lastlow:=0;
  lastHigh:=0;

  //    
  shift:=(Bars-Depth);
  while shift>=0 do
  begin

     //     depth    shift
     val:=GetLowestValue(vt_Low,shift,depth);

     //  
     if(val = lastlow) then
        val:=0.0 //  
     else
        begin
          lastlow:=val; //  
          if((Low(shift)-val)>(Deviation*Point)) then
             val:=0.0   //    
          else
             begin
                //   BackStep     
                back:=1;
                while back<=BackStep do
                   begin
                      res:=lowBuffer[shift+back];
                      if ((res<>0)and(res<>val)) then
                         lowBuffer[shift+back]:=0.0;

                       back:=back + 1;
                   end;
             end;

        end;

      lowBuffer[shift]:=val; //  

      //   (High)
      val:=GetHighestValue(vt_High,shift,depth);

      if (val=lasthigh) then
         val:=0.0
      else
         begin
           lastHigh:=val;

           if((val-High(shift))>(Deviation*Point)) then
              val:=0.0
           else
              begin
                 back:=1;
                 while back<=Backstep do
                    begin
                       res:=highBuffer[shift+back];
                       if((res<>0)and(res<val)) then
                          highBuffer[shift+back]:=0.0;

                        back:=back+1;
                    end;
              end;
           end;

        highBuffer[shift]:=val;

        shift := shift - 1;
     end; {while}


  //   -  
  //        
  //     (/).
  //   :   - .
  lasthigh:=-1;
  lasthighpos:=-1;
  lastlow:=-1;
  lastlowpos:=-1;

  shift:=(Bars-Depth);
  while shift>=0 do
  begin
     curlow:=lowBuffer[shift];
     curhigh:=highBuffer[shift];

     if not ((curlow = 0) and (curhigh = 0)) then
         begin
            if (curhigh<>0) then
               begin
                  if (lasthigh>0) then
                      if (lasthigh<curhigh) then
                          highBuffer[lasthighpos]:=0
                      else
                          highBuffer[shift]:=0;

                  if (lasthigh<curhigh) or (lasthigh<0) then
                     begin
                       lasthigh:=curhigh;
                       lasthighpos:=shift;
                     end;

                 lastlow:=-1;
               end;

             if (curlow<>0) then
                begin
                  if (lastlow>0) then
                     begin
                        if(lastlow>curlow) then
                            LowBuffer[lastlowpos]:=0.0
                        else
                            LowBuffer[shift]:=0.0;
                     end;

                  if((curlow<lastlow)or(lastlow<0.0)) then
                     begin
                       lastlow:=curlow;
                       lastlowpos:=shift;
                     end;

                  lasthigh:=-1;
                end;
         end;
     shift:=shift - 1;
  end;

  //   - .
  //       lowBuffer.
  shift:=Bars-1;
  while shift>=0 do
  begin
     if(shift>=Bars-Depth) then
         lowBuffer[shift]:=0.0
     else
         begin
            res:=highBuffer[shift];
            if (res<>0.0) then
               lowBuffer[shift]:=res;
         end;

     shift:=shift - 1;
  end;

end;



exports

//       

Init, Done, Calculate;



end.


